#include <stdlib.h>
#include <stdio.h>
//#define DEBUG
#include "global.h"
#include "abf.h"
#include "timer.h"

int main(int argc, char *argv[]) {
	int i1,i2;
	double abf_time_mit,abf_time_ohne;

	if(argc != 3) {
		printf("Usage: %s <pattern> <text>\n",argv[0]);
		return(-1);
	}

	openpattern(argv[1]);
	opentext(argv[2]);
	init_lists();
	init_waves();

	start_timer(0);
	seriell_witness();
	start_timer(1);
	cons_check();
	waves();
	abf_time_mit=stop_timer(0);
	abf_time_ohne=stop_timer(1);

	printf("Die Lsungen:\n");
	for(i1=0; i1<n; i1++)
		printCi(i1);

	printf("mit Vorverarbeitung: %lf - ohne Vorverarbeitung: %lf (Millisekunden)\n\n",abf_time_mit,abf_time_ohne);

	return(0);
}
