/* Implementirung der Algorithmen aus ML-84 */
#include <stdio.h>
#include <stdlib.h>


int main(int argc, char *argv[]) {
	char *W;
	char *T;
	int i,j,m,n,bx,k;
	int lppattern[256];
	int lptext[256];

	if(argc != 3) {
		printf("Usage: %s <W> <T>\n\n",argv[0]);
		return(-1);
	}

	W=argv[1];
	T=argv[2];

	printf("W=%s\nT=%s\n",W,T);

	/* lppattern */
	m=strlen(W);
	printf("m=%i\n",m);
	lppattern[0]=m;
	
	j=0;
	while(W[j] == W[j+1]) 
		j++;
	lppattern[1]=j;
	k=1;
	
	for(i=2; i<=m-1; i++) {
			bx=k+lppattern[k]-i;
			if(lppattern[i-k] < bx) {
				lppattern[i]=lppattern[i-k];
			} else {
				if(i >= k+lppattern[k])
					j=0;
				else
					j=bx;
				while(W[j] == W[j+i])
					j++;
				lppattern[i]=j;
				k=i;
			}	
	}

	printf("Nach lppattern(W):\nlppattern=");
	for(i=0; i<m; i++) {
		printf("%i ",lppattern[i]);
	}
	putchar('\n');


	/* lptext */
	n=strlen(T);
	printf("n=%i\n",n);

	j=0;
	while(W[j] == T[j])
		j++;
	lptext[0]=j;
	k=0;

	for(i=1; i<=n-1; i++) {
		bx=k+lptext[k]-i;
		if(lppattern[i-k] < bx) {
			lptext[i]=lppattern[i-k];
		} else {
			if(j >= k+lptext[k]) 
				j=0;
			else
				j=bx;
			while(W[j] == T[j+i])
				j++;
			lptext[i]=j;
			k=i;
		}
	}

	printf("Nach lptext(W,T):\nlptext=");
	for(i=0; i<n; i++) {
		printf("%i ",lptext[i]);
	}
	putchar('\n');
	return(0);
}
