#include <stdlib.h>
#include <stdio.h>
#include "global.h"
#include "abf.h"
#include "trivial.h"
#include "ku.h"
#include "timer.h"

/* ---------------- */
#define TMPTXT "/tmp/text.txt"
#define TMPPAT "/tmp/pattern.txt"
#define OTHERX 'X'
/* ---------------- */

#include "tests.h"

/* Generiert wird ein 4000x4000 grosser nichttrivialer Text bestehend aus "X" und "-" */
/* Hier wird das Muster genau i1 mal gefunden */

int main(int argc, char *argv[]) {
	int i1,i2,i3;
	char c1;
	double abf_time_mit,abf_time_ohne,trivial_time,ku_sq_mit,ku_sq_ohne;
	FILE *datei,*tmptext,*tmppattern;

	printf("Wachsende Zahl von Fundstellen\n");
	printf("n\t\ttrivial\t\tabf_ohne\tabf_mit\t\tku_sq_ohne\tku_sq_mit\tku_lin_ohne\tku_lin_mit\ttriv_proz\tabf_proz\tsqu_proz\tlin_proz\n");

	tmppattern=fopen(TMPPAT,"w");
	if(tmppattern == (FILE *)NULL) {
		printf("unable to open %s\n\n",TMPPAT);
		return(-1);
	}

	for(i2=0; i2<5; i2++) {
		for(i3=0; i3<5; i3++) {
			if(i3==i2) {
				fputc('X',tmppattern);
			} else {
				fputc('-',tmppattern);
			}
		}
		fputc('\n',tmppattern);
	}
	fclose(tmppattern);

	for(i1=4; i1<4000; i1+=100) {

		tmptext=fopen(TMPTXT,"w");
		if(tmptext == (FILE *)NULL) {
			printf("unable to open %s\n\n",TMPTXT);
			return(-1);
		}


		for(i2=0; i2<4000; i2++) {
			for(i3=0; i3<4000; i3++) {
					if(i2<i1 && i3==i2) {
						fputc('X',tmptext);
					} else { 
						if(abs(i3-i2) > 6 && rand()%2 == 1 && i2%2 == 1) 
							fputc(OTHERX,tmppattern);
						else
							fputc('-',tmptext);
					}
			}
			fputc('\n',tmptext);
		}
		fclose(tmptext);	

		runtests(2,i1-4);

	}

	return(0);
}
