void runtests(c,num) {
  double abf_time_mit,abf_time_ohne,trivial_time,ku_sq_mit,ku_sq_ohne, ku_lin_mit, ku_lin_ohne;

  /* init global */
  openpattern(TMPPAT);
  opentext(TMPTXT);
  init_lists();
  init_waves();

  /* ABF */
  start_timer(0);
  seriell_witness();
  start_timer(1);
  cons_check();
  waves();
  abf_time_mit=stop_timer(0);
  abf_time_ohne=stop_timer(1);

  /* trivial */
  start_timer(0);
  trivial_search();
  trivial_time=stop_timer(0);

  /* Quadratische Vorlagen */
  init_ku(c);
  start_timer(0);
  ku_quadratic_search_pre();
  start_timer(1);
  ku_quadratic_search();
  ku_sq_mit=stop_timer(0);
  ku_sq_ohne=stop_timer(1);

	/* Lineare Vorlagen */
	init_ku(c);
	start_timer(0);
	ku_linear_search_pre();
	start_timer(1);
	ku_linear_search();
	ku_lin_mit=stop_timer(0);
	ku_lin_ohne=stop_timer(1);

  /* output */
  printf("%i\t\t%lf\t%lf\t%lf\t%lf\t%lf\t%lf\t%lf",num,trivial_time,abf_time_ohne,abf_time_mit,ku_sq_ohne,ku_sq_mit,ku_lin_ohne,ku_lin_mit);
	printf("\t0\t");
	printf("\t%lf",(abf_time_mit-abf_time_ohne)/abf_time_mit);
	printf("\t%lf",(ku_sq_mit-ku_sq_ohne)/ku_sq_mit);
	printf("\t%lf",(ku_lin_mit-ku_lin_ohne)/ku_lin_mit);
	putchar('\n');
	
}
